package com.ecoflow.prm.controller;

package ..deTemp.1745734361820;

import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.ecoflow.prm.vo.ImageVO;
import java.util.ArrayList;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

@Controller
@RequestMapping({"/page"})
public class PageController {
  private static final Logger log = LoggerFactory.getLogger(com.ecoflow.prm.controller.PageController.class);
  
  @RequestMapping({"/imageList"})
  public ModelAndView imageList(ModelAndView view, String refname) {
    List<ImageVO> list = new ArrayList<>();
    String GIT_LAB_URL = "http://it-gitlab.ecoflow.com";
    String TOKEN = "zVwHBsn8RSjoPiy5EoJa";
    String API = GIT_LAB_URL + "/api/v4/projects?per_page=100";
    String body = ((HttpRequest)HttpRequest.get(API).header("PRIVATE-TOKEN", TOKEN)).execute().body();
    JSONArray projects = JSONArray.parseArray(body);
    for (int i = 0; i < projects.size(); i++) {
      JSONObject obj = projects.getJSONObject(i);
      int id = obj.getInteger("id").intValue();
      String namespace = obj.getString("path_with_namespace");
      API = GIT_LAB_URL + "/api/v4/projects/" + id + "/repository/commits?ref_name=" + refname;
      body = ((HttpRequest)HttpRequest.get(API).header("PRIVATE-TOKEN", TOKEN)).execute().body();
      JSONArray commits = JSONArray.parseArray(body);
      if (commits.size() > 0) {
        String shortId = commits.getJSONObject(0).getString("short_id");
        String committedDate = commits.getJSONObject(0).getString("committed_date");
        String committerEmail = commits.getJSONObject(0).getString("committer_email");
        String imageName = "harbor.ecoflow.com/it/" + namespace + ":master-" + shortId;
        log.info("镜像名称:{}", imageName);
        ImageVO vo = new ImageVO(imageName, committedDate, committerEmail);
        list.add(vo);
      } 
    } 
    view.addObject("list", list);
    view.setViewName("imageList");
    return view;
  }
}
